diff -ruN vdr-1.7.33/newplugin vdr-1.7.34/newplugin
--- vdr-1.7.33/newplugin	2012-03-11 16:34:26.000000000 +0100
+++ vdr-1.7.34/newplugin	2012-12-23 11:05:22.000000000 +0100
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 2.8 2012/03/11 15:34:26 kls Exp $
+# $Id: newplugin 2.14 2012/12/23 10:05:22 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -65,48 +65,45 @@
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
 # By default the main source file also carries this name.
-# IMPORTANT: the presence of this macro is important for the Make.config
-# file. So it must be defined, even if it is not used here!
-#
+
 PLUGIN = $PLUGIN_NAME
 
 ### The version number of this plugin (taken from the main source file):
 
 VERSION = \$(shell grep 'static const char \\*VERSION *=' \$(PLUGIN).c | awk '{ print \$\$6 }' | sed -e 's/[";]//g')
 
-### The C++ compiler and options:
-
-CXX      ?= g++
-CXXFLAGS ?= -g -O3 -Wall -Werror=overloaded-virtual -Wno-parentheses
-
 ### The directory environment:
 
-VDRDIR ?= ../../..
-LIBDIR ?= ../../lib
+# Use package data if installed...otherwise assume we're under the VDR source directory:
+PKGCFG = \$(if \$(VDRDIR),\$(shell pkg-config --variable=\$(1) \$(VDRDIR)/vdr.pc),\$(shell pkg-config --variable=\$(1) vdr || pkg-config --variable=\$(1) ../../../vdr.pc))
+LIBDIR = \$(DESTDIR)\$(call PKGCFG,libdir)
+LOCDIR = \$(DESTDIR)\$(call PKGCFG,locdir)
+#
 TMPDIR ?= /tmp
 
-### Make sure that necessary options are included:
-
-include \$(VDRDIR)/Make.global
-
-### Allow user defined options to overwrite defaults:
+### The compiler options:
 
--include \$(VDRDIR)/Make.config
+export CFLAGS   = \$(call PKGCFG,cflags)
+export CXXFLAGS = \$(call PKGCFG,cxxflags)
 
-### The version number of VDR's plugin API (taken from VDR's "config.h"):
+### The version number of VDR's plugin API:
 
-APIVERSION = \$(shell sed -ne '/define APIVERSION/s/^.*"\\(.*\\)".*\$\$/\\1/p' \$(VDRDIR)/config.h)
+APIVERSION = \$(call PKGCFG,apiversion)
 
 ### The name of the distribution archive:
 
 ARCHIVE = \$(PLUGIN)-\$(VERSION)
 PACKAGE = vdr-\$(ARCHIVE)
 
+### The name of the shared object file:
+
+SOFILE = libvdr-\$(PLUGIN).so
+
 ### Includes and Defines (add further entries here):
 
-INCLUDES += -I\$(VDRDIR)/include
+INCLUDES +=
 
-DEFINES += -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"\$(PLUGIN)"'
+DEFINES += -DPLUGIN_NAME_I18N='"\$(PLUGIN)"'
 
 ### The object files (add further files here):
 
@@ -114,7 +111,7 @@
 
 ### The main target:
 
-all: libvdr-\$(PLUGIN).so i18n
+all: \$(SOFILE) i18n
 
 ### Implicit rules:
 
@@ -133,33 +130,38 @@
 ### Internationalization (I18N):
 
 PODIR     = po
-LOCALEDIR = \$(VDRDIR)/locale
 I18Npo    = \$(wildcard \$(PODIR)/*.po)
-I18Nmsgs  = \$(addprefix \$(LOCALEDIR)/, \$(addsuffix /LC_MESSAGES/vdr-\$(PLUGIN).mo, \$(notdir \$(foreach file, \$(I18Npo), \$(basename \$(file))))))
+I18Nmo    = \$(addsuffix .mo, \$(foreach file, \$(I18Npo), \$(basename \$(file))))
+I18Nmsgs  = \$(addprefix \$(LOCDIR)/, \$(addsuffix /LC_MESSAGES/vdr-\$(PLUGIN).mo, \$(notdir \$(foreach file, \$(I18Npo), \$(basename \$(file))))))
 I18Npot   = \$(PODIR)/\$(PLUGIN).pot
 
 %.mo: %.po
 	msgfmt -c -o \$\@ \$<
 
 \$(I18Npot): \$(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=vdr-\$(PLUGIN) --package-version=\$(VERSION) --msgid-bugs-address='<see README>' -o \$\@ \$^
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=vdr-\$(PLUGIN) --package-version=\$(VERSION) --msgid-bugs-address='<see README>' -o \$\@ `ls \$^`
 
 %.po: \$(I18Npot)
-	msgmerge -U --no-wrap --no-location --backup=none -q \$\@ \$<
+	msgmerge -U --no-wrap --no-location --backup=none -q -N \$\@ \$<
 	\@touch \$\@
 
-\$(I18Nmsgs): \$(LOCALEDIR)/%/LC_MESSAGES/vdr-\$(PLUGIN).mo: \$(PODIR)/%.mo
-	\@mkdir -p \$(dir \$@)
-	cp \$< \$\@
+\$(I18Nmsgs): \$(LOCDIR)/%/LC_MESSAGES/vdr-\$(PLUGIN).mo: \$(PODIR)/%.mo
+	install -D -m644 \$< \$\@
 
 .PHONY: i18n
-i18n: \$(I18Nmsgs) \$(I18Npot)
+i18n: \$(I18Nmo) \$(I18Npot)
+
+install-i18n: \$(I18Nmsgs)
 
 ### Targets:
 
-libvdr-\$(PLUGIN).so: \$(OBJS)
+\$(SOFILE): \$(OBJS)
 	\$(CXX) \$(CXXFLAGS) \$(LDFLAGS) -shared \$(OBJS) -o \$\@
-	\@cp --remove-destination \$\@ \$(LIBDIR)/\$\@.\$(APIVERSION)
+
+install-lib: \$(SOFILE)
+	install -D \$^ \$(LIBDIR)/\$^.\$(APIVERSION)
+
+install: install-lib install-i18n
 
 dist: \$(I18Npo) clean
 	\@-rm -rf \$(TMPDIR)/\$(ARCHIVE)
@@ -170,7 +172,8 @@
 	\@echo Distribution package created as \$(PACKAGE).tgz
 
 clean:
-	\@-rm -f \$(OBJS) \$(DEPFILE) *.so *.tgz core* *~ \$(PODIR)/*.mo \$(PODIR)/*.pot
+	\@-rm -f \$(PODIR)/*.mo \$(PODIR)/*.pot
+	\@-rm -f \$(OBJS) \$(DEPFILE) *.so *.tgz core* *~
 };
 
 $MAIN = qq
@@ -349,4 +352,3 @@
   print FILE $Content;
   close(FILE);
 }
-
diff -ruN vdr-1.7.33/osd.c vdr-1.7.34/osd.c
--- vdr-1.7.33/osd.c	2012-06-09 16:37:24.000000000 +0200
+++ vdr-1.7.34/osd.c	2012-12-15 12:16:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 2.32 2012/06/09 14:37:24 kls Exp $
+ * $Id: osd.c 2.33 2012/12/15 11:16:41 kls Exp $
  */
 
 #include "osd.h"
@@ -1683,9 +1683,7 @@
 
 cBitmap *cOsd::GetBitmap(int Area)
 {
-  if (isTrueColor)
-     Area = 0; // returns the dummy bitmap
-  return Area < numBitmaps ? bitmaps[Area] : NULL;
+  return Area < numBitmaps ? (isTrueColor ? bitmaps[0] : bitmaps[Area]) : NULL;
 }
 
 cPixmap *cOsd::CreatePixmap(int Layer, const cRect &ViewPort, const cRect &DrawPort)
diff -ruN vdr-1.7.33/recording.c vdr-1.7.34/recording.c
--- vdr-1.7.33/recording.c	2012-12-06 10:35:13.000000000 +0100
+++ vdr-1.7.34/recording.c	2012-12-23 16:11:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.78 2012/12/06 09:35:13 kls Exp $
+ * $Id: recording.c 2.81 2012/12/23 15:11:28 kls Exp $
  */
 
 #include "recording.h"
@@ -1666,7 +1666,8 @@
 #define INDEXFILESUFFIX     "/index"
 
 // The maximum time to wait before giving up while catching up on an index file:
-#define MAXINDEXCATCHUP   8 // seconds
+#define MAXINDEXCATCHUP    8 // number of retries
+#define INDEXCATCHUPWAIT 100 // milliseconds
 
 struct tIndexPes {
   uint32_t offset;
@@ -1693,9 +1694,6 @@
 #define INDEXFILECHECKINTERVAL 500 // ms between checks for existence of the regenerated index file
 #define INDEXFILETESTINTERVAL   10 // ms between tests for the size of the index file in case of pausing live video
 
-cMutex cIndexFile::indexListMutex;
-cVector<const cIndexFile *> cIndexFile::indexList;
-
 cIndexFile::cIndexFile(const char *FileName, bool Record, bool IsPesRecording, bool PauseLive)
 :resumeFile(FileName, IsPesRecording)
 {
@@ -1776,13 +1774,10 @@
            LOG_ERROR_STR(*fileName);
         }
      }
-  if (Record)
-     AddToIndexList(this);
 }
 
 cIndexFile::~cIndexFile()
 {
-  RemoveFromIndexList(this);
   if (f >= 0)
      close(f);
   free(index);
@@ -1824,14 +1819,11 @@
   // returns true unless something really goes wrong, so that 'index' becomes NULL
   if (index && f >= 0) {
      cMutexLock MutexLock(&mutex);
-     for (int i = 0; i <= MAXINDEXCATCHUP && (Index < 0 || Index > last); i++) {
+     // Note that CatchUp() is triggered even if Index is 'last' (and thus valid).
+     // This is done to make absolutely sure we don't miss any data at the very end.
+     for (int i = 0; i <= MAXINDEXCATCHUP && (Index < 0 || Index >= last); i++) {
          struct stat buf;
          if (fstat(f, &buf) == 0) {
-            if (!IsInIndexList(this)) {
-               close(f);
-               f = -1;
-               break;
-               }
             int newLast = int(buf.st_size / sizeof(tIndexTs) - 1);
             if (newLast > last) {
                int NewSize = size;
@@ -1869,9 +1861,9 @@
             }
          else
             LOG_ERROR_STR(*fileName);
-         if (Index <= last)
+         if (Index < last)
             break;
-         cCondWait::SleepMs(1000);
+         cCondWait::SleepMs(INDEXCATCHUPWAIT);
          }
      }
   return index != NULL;
@@ -1937,15 +1929,16 @@
                *FileNumber = index[Index].number;
                *FileOffset = index[Index].offset;
                if (Length) {
-                  // all recordings end with a non-independent frame, so the following should be safe:
-                  uint16_t fn = index[Index + 1].number;
-                  off_t fo = index[Index + 1].offset;
-                  if (fn == *FileNumber)
-                     *Length = int(fo - *FileOffset);
-                  else {
-                     esyslog("ERROR: 'I' frame at end of file #%d", *FileNumber);
-                     *Length = -1;
+                  if (Index < last) {
+                     uint16_t fn = index[Index + 1].number;
+                     off_t fo = index[Index + 1].offset;
+                     if (fn == *FileNumber)
+                        *Length = int(fo - *FileOffset);
+                     else
+                        *Length = -1; // this means "everything up to EOF" (the buffer's Read function will act accordingly)
                      }
+                  else
+                     *Length = -1;
                   }
                return Index;
                }
@@ -2025,39 +2018,6 @@
   return -1;
 }
 
-void cIndexFile::AddToIndexList(const cIndexFile *IndexFile)
-{
-  cMutexLock MutexLock(&indexListMutex);
-  for (int i = 0; i < indexList.Size(); i++) {
-      if (!indexList[i]) {
-         indexList[i] = IndexFile;
-         return;
-         }
-      }
-  indexList.Append(IndexFile);
-}
-
-void cIndexFile::RemoveFromIndexList(const cIndexFile *IndexFile)
-{
-  cMutexLock MutexLock(&indexListMutex);
-  for (int i = 0; i < indexList.Size(); i++) {
-      if (indexList[i] == IndexFile) {
-         indexList[i] = NULL;
-         return;
-         }
-      }
-}
-
-bool cIndexFile::IsInIndexList(const cIndexFile *IndexFile)
-{
-  cMutexLock MutexLock(&indexListMutex);
-  for (int i = 0; i < indexList.Size(); i++) {
-      if (indexList[i] && !strcmp(indexList[i]->fileName, IndexFile->fileName))
-         return true;
-      }
-  return false;
-}
-
 bool GenerateIndex(const char *FileName) 
 {
   if (DirectoryOk(FileName)) {
diff -ruN vdr-1.7.33/recording.h vdr-1.7.34/recording.h
--- vdr-1.7.33/recording.h	2012-11-13 12:43:59.000000000 +0100
+++ vdr-1.7.34/recording.h	2012-12-23 16:11:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.40 2012/11/13 11:43:59 kls Exp $
+ * $Id: recording.h 2.41 2012/12/23 15:11:53 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -292,11 +292,6 @@
   cResumeFile resumeFile;
   cIndexFileGenerator *indexFileGenerator;
   cMutex mutex;
-  static cMutex indexListMutex;
-  static cVector<const cIndexFile *> indexList;
-  static void AddToIndexList(const cIndexFile *IndexFile);
-  static void RemoveFromIndexList(const cIndexFile *IndexFile);
-  static bool IsInIndexList(const cIndexFile *IndexFile);
   void ConvertFromPes(tIndexTs *IndexTs, int Count);
   void ConvertToPes(tIndexTs *IndexTs, int Count);
   bool CatchUp(int Index = -1);
diff -ruN vdr-1.7.33/skins.h vdr-1.7.34/skins.h
--- vdr-1.7.33/skins.h	2012-12-07 18:18:44.000000000 +0100
+++ vdr-1.7.34/skins.h	2012-12-21 12:09:13.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.h 2.7 2012/12/07 17:18:44 kls Exp $
+ * $Id: skins.h 2.9 2012/12/21 11:09:13 kls Exp $
  */
 
 #ifndef __SKINS_H
@@ -73,7 +73,37 @@
   */
   };
 
-enum eMenuCategory { mcUndefined = -1, mcUnknown = 0, mcMain, mcSchedule, mcChannel, mcTimer, mcRecording, mcPlugin, mcSetup, mcCommand, mcEvent, mcText, mcFolder, mcCam };
+enum eMenuCategory {
+  mcUndefined = -1,
+  mcUnknown = 0,
+  mcMain,
+  mcSchedule,
+  mcScheduleNow,
+  mcScheduleNext,
+  mcChannel,
+  mcChannelEdit,
+  mcTimer,
+  mcTimerEdit,
+  mcRecording,
+  mcRecordingInfo,
+  mcPlugin,
+  mcPluginSetup,
+  mcSetup,
+  mcSetupOsd,
+  mcSetupEpg,
+  mcSetupDvb,
+  mcSetupLnb,
+  mcSetupCam,
+  mcSetupRecord,
+  mcSetupReplay,
+  mcSetupMisc,
+  mcSetupPlugins,
+  mcCommand,
+  mcEvent,
+  mcText,
+  mcFolder,
+  mcCam
+  };
 
 class cSkinDisplayMenu : public cSkinDisplay {
        ///< This class implements the general purpose menu display, which is
@@ -153,7 +183,7 @@
        ///< this function will be first called for the old current item
        ///< with Current set to false, and then for the new current item
        ///< with Current set to true.
-  virtual bool SetItemEvent(const cEvent *Event, int Index, bool Current, bool Selectable, const cChannel *Channel, bool WithDate, int TimerMatch) { return false; }
+  virtual bool SetItemEvent(const cEvent *Event, int Index, bool Current, bool Selectable, const cChannel *Channel, bool WithDate, eTimerMatch TimerMatch) { return false; }
        ///< Sets the item at the given Index to Event. See SetItem() for more information.
        ///< If a derived skin class implements this function, it can display an Event item
        ///< in a more elaborate way than just a simple line of text.
